<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>A4988Driver: a4988.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">A4988Driver
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#enum-members">Enumerations</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">a4988.h File Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>This library manages a Pololu A4988 stepper motor driver. This library does not drive SLEEP mode.  
<a href="#details">More...</a></p>
<div class="textblock"><code>#include &quot;stdint.h&quot;</code><br />
<code>#include &quot;stdbool.h&quot;</code><br />
<code>#include &quot;main.h&quot;</code><br />
<code>#include &quot;stm32f1xx.h&quot;</code><br />
<code>#include &quot;stm32f1xx_hal.h&quot;</code><br />
<code>#include &quot;stm32f1xx_hal_gpio.h&quot;</code><br />
<code>#include &quot;gpio.h&quot;</code><br />
</div>
<p><a href="a4988_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structa4988_handler.html">a4988Handler</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">this struct saves all the information related to the driver status.  <a href="structa4988_handler.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="enum-members"></a>
Enumerations</h2></td></tr>
<tr class="memitem:a6086cd48f9d99d3c531787235d509622"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a4988_8h.html#a6086cd48f9d99d3c531787235d509622">driverStatus</a> { <a class="el" href="a4988_8h.html#a6086cd48f9d99d3c531787235d509622a33cf1d8ef1d06ee698a7fabf40eb3a7f">ACTIVE</a>, 
<a class="el" href="a4988_8h.html#a6086cd48f9d99d3c531787235d509622aac132f2982b98bcaa3445e535a03ff75">OFF</a>, 
<a class="el" href="a4988_8h.html#a6086cd48f9d99d3c531787235d509622ad6137abebe4fdc59e2f0f2c84bdbe3fa">SLEEP</a>
 }<tr class="memdesc:a6086cd48f9d99d3c531787235d509622"><td class="mdescLeft">&#160;</td><td class="mdescRight">Possible status of the driver.  <a href="a4988_8h.html#a6086cd48f9d99d3c531787235d509622">More...</a><br /></td></tr>
</td></tr>
<tr class="separator:a6086cd48f9d99d3c531787235d509622"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a26a4a9fc10f890a34859f53d114f08b0"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0">microStep</a> { <br />
&#160;&#160;<a class="el" href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0ad08f8ac0aa8dfb59589824359772459e">FULL</a> = 1, 
<a class="el" href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0a51df22c376649e022134d738e8d8641a">HALF</a> = 2, 
<a class="el" href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0a8dd9342a0e4fd716d2beb9961f5deeed">QUARTER</a> = 4, 
<a class="el" href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0a2fd39b67b424f4ea3b4c11ce3195ab8b">EIGHT</a> = 8, 
<br />
&#160;&#160;<a class="el" href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0a3cc9428274f66ec477863bbf676438c8">SIXTEENTH</a> = 16
<br />
 }<tr class="memdesc:a26a4a9fc10f890a34859f53d114f08b0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Microsteps set in the driver by pins MS1, MS2, MS3.  <a href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0">More...</a><br /></td></tr>
</td></tr>
<tr class="separator:a26a4a9fc10f890a34859f53d114f08b0"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a83a5e4ad4b743e7a5e5e3667d5b5af90"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a4988_8h.html#a83a5e4ad4b743e7a5e5e3667d5b5af90">a4988_init</a> (<a class="el" href="structa4988_handler.html">a4988Handler</a> *driver_handler, GPIO_TypeDef *en_port, uint32_t en_pin, GPIO_TypeDef *step_port, uint32_t step_pin, GPIO_TypeDef *dir_port, uint32_t dir_pin)</td></tr>
<tr class="memdesc:a83a5e4ad4b743e7a5e5e3667d5b5af90"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize the driver. Assigns the pins for each control in order to control the motor.  <a href="#a83a5e4ad4b743e7a5e5e3667d5b5af90">More...</a><br /></td></tr>
<tr class="separator:a83a5e4ad4b743e7a5e5e3667d5b5af90"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6cd8fcd5ab73faea97783466d496782b"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a4988_8h.html#a6cd8fcd5ab73faea97783466d496782b">a4988_incStep</a> (<a class="el" href="structa4988_handler.html">a4988Handler</a> *driver_handler)</td></tr>
<tr class="memdesc:a6cd8fcd5ab73faea97783466d496782b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Increments a step in the motor.  <a href="#a6cd8fcd5ab73faea97783466d496782b">More...</a><br /></td></tr>
<tr class="separator:a6cd8fcd5ab73faea97783466d496782b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a616386d44c4d6ab3acd4bfe79f4526c3"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a4988_8h.html#a616386d44c4d6ab3acd4bfe79f4526c3">a4988_incSteps</a> (<a class="el" href="structa4988_handler.html">a4988Handler</a> *driver_handler, uint32_t steps)</td></tr>
<tr class="memdesc:a616386d44c4d6ab3acd4bfe79f4526c3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Increments an specific amount of steps in the motor.  <a href="#a616386d44c4d6ab3acd4bfe79f4526c3">More...</a><br /></td></tr>
<tr class="separator:a616386d44c4d6ab3acd4bfe79f4526c3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a25f9bb9576d05153c805e499b5ead280"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a4988_8h.html#a25f9bb9576d05153c805e499b5ead280">a4988_decStep</a> (<a class="el" href="structa4988_handler.html">a4988Handler</a> *driver_handler)</td></tr>
<tr class="memdesc:a25f9bb9576d05153c805e499b5ead280"><td class="mdescLeft">&#160;</td><td class="mdescRight">Decrements a simgle step in the motor.  <a href="#a25f9bb9576d05153c805e499b5ead280">More...</a><br /></td></tr>
<tr class="separator:a25f9bb9576d05153c805e499b5ead280"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a694a6c6580c3e70029ecf890b18662d9"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a4988_8h.html#a694a6c6580c3e70029ecf890b18662d9">a4988_decSteps</a> (<a class="el" href="structa4988_handler.html">a4988Handler</a> *driver_handler, uint32_t steps)</td></tr>
<tr class="memdesc:a694a6c6580c3e70029ecf890b18662d9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Decrements an specific amount of steps in the motor.  <a href="#a694a6c6580c3e70029ecf890b18662d9">More...</a><br /></td></tr>
<tr class="separator:a694a6c6580c3e70029ecf890b18662d9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a50b770ddd61a733c0b93674a6e043941"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a4988_8h.html#a50b770ddd61a733c0b93674a6e043941">a4988_setMicroStep</a> (<a class="el" href="structa4988_handler.html">a4988Handler</a> *driver_handler, <a class="el" href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0">microStep</a> step)</td></tr>
<tr class="memdesc:a50b770ddd61a733c0b93674a6e043941"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets how many microsteps are set in Pololu driver To check hoe many microsteps are configured, check MS1, MS2 and MS3.  <a href="#a50b770ddd61a733c0b93674a6e043941">More...</a><br /></td></tr>
<tr class="separator:a50b770ddd61a733c0b93674a6e043941"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2c4fb12bcdcffea40744538616b5f7e4"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a4988_8h.html#a2c4fb12bcdcffea40744538616b5f7e4">a4988_setStepsPerTurn</a> (<a class="el" href="structa4988_handler.html">a4988Handler</a> *driver_handler, float steps)</td></tr>
<tr class="memdesc:a2c4fb12bcdcffea40744538616b5f7e4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the amount of steps to make in order to rotate a turn. DO NOT TAKE IN COUNT MICROSTEPS. See Stepper motor datasheet.  <a href="#a2c4fb12bcdcffea40744538616b5f7e4">More...</a><br /></td></tr>
<tr class="separator:a2c4fb12bcdcffea40744538616b5f7e4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8c6e8d00fb33d5b8d8b1be976b2d8773"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a4988_8h.html#a8c6e8d00fb33d5b8d8b1be976b2d8773">a4988_setSteps</a> (<a class="el" href="structa4988_handler.html">a4988Handler</a> *driver_handler, int64_t steps)</td></tr>
<tr class="memdesc:a8c6e8d00fb33d5b8d8b1be976b2d8773"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set a new amount of steps taken.  <a href="#a8c6e8d00fb33d5b8d8b1be976b2d8773">More...</a><br /></td></tr>
<tr class="separator:a8c6e8d00fb33d5b8d8b1be976b2d8773"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a05f902e3d1ee0b82d70fa65d8955423b"><td class="memItemLeft" align="right" valign="top">float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a4988_8h.html#a05f902e3d1ee0b82d70fa65d8955423b">a4988_getDegreeCount</a> (<a class="el" href="structa4988_handler.html">a4988Handler</a> *driver_handler)</td></tr>
<tr class="memdesc:a05f902e3d1ee0b82d70fa65d8955423b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get how many degrees has the motor rotated.  <a href="#a05f902e3d1ee0b82d70fa65d8955423b">More...</a><br /></td></tr>
<tr class="separator:a05f902e3d1ee0b82d70fa65d8955423b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab2c561e95b718d8f275f41f7ec44113b"><td class="memItemLeft" align="right" valign="top">int64_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a4988_8h.html#ab2c561e95b718d8f275f41f7ec44113b">a4988_getSteps</a> (<a class="el" href="structa4988_handler.html">a4988Handler</a> *driver_handler)</td></tr>
<tr class="memdesc:ab2c561e95b718d8f275f41f7ec44113b"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the number of steps that the motor has made.  <a href="#ab2c561e95b718d8f275f41f7ec44113b">More...</a><br /></td></tr>
<tr class="separator:ab2c561e95b718d8f275f41f7ec44113b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4636e615969f0762717be85f3fae99b2"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a4988_8h.html#a4636e615969f0762717be85f3fae99b2">a4988_resetSteps</a> (<a class="el" href="structa4988_handler.html">a4988Handler</a> *driver_handler)</td></tr>
<tr class="memdesc:a4636e615969f0762717be85f3fae99b2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reset the step count of the motor.  <a href="#a4636e615969f0762717be85f3fae99b2">More...</a><br /></td></tr>
<tr class="separator:a4636e615969f0762717be85f3fae99b2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aac1c631bf4552cbc8e1af42cf426f154"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a4988_8h.html#aac1c631bf4552cbc8e1af42cf426f154">a4988_setStatus</a> (<a class="el" href="structa4988_handler.html">a4988Handler</a> *driver_handler, <a class="el" href="a4988_8h.html#a6086cd48f9d99d3c531787235d509622">driverStatus</a> status)</td></tr>
<tr class="memdesc:aac1c631bf4552cbc8e1af42cf426f154"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the motor to ACTIVE or OFF.  <a href="#aac1c631bf4552cbc8e1af42cf426f154">More...</a><br /></td></tr>
<tr class="separator:aac1c631bf4552cbc8e1af42cf426f154"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a957c1d38216e19e2d33514fba8290797"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a4988_8h.html#a957c1d38216e19e2d33514fba8290797">a4988_setSpeed</a> (<a class="el" href="structa4988_handler.html">a4988Handler</a> *driver_handler, uint32_t speed)</td></tr>
<tr class="memdesc:a957c1d38216e19e2d33514fba8290797"><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculates the delay of each step in order to reach the desired speed. In order to calculate it properly, microsteps and steps per turn must be set.  <a href="#a957c1d38216e19e2d33514fba8290797">More...</a><br /></td></tr>
<tr class="separator:a957c1d38216e19e2d33514fba8290797"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This library manages a Pololu A4988 stepper motor driver. This library does not drive SLEEP mode. </p>
<p>A4988 library</p>
<dl class="section author"><dt>Author</dt><dd>Gonzalo Cervetti </dd></dl>
<dl class="section date"><dt>Date</dt><dd>Sep 14, 2019 </dd></dl>
<dl class="section version"><dt>Version</dt><dd>1.0 </dd></dl>
<dl class="section copyright"><dt>Copyright</dt><dd>GNU Public License. </dd></dl>
<h1><a class="anchor" id="sec"></a>
Pin naming</h1>
<p>pin assignment <br />
 GPIO_TypeDef *EN_PORT = Port of ENABLE pin. <br />
 uint16_t EN_PIN = ENABLE pin. <br />
 GPIO_TypeDef *STEP_PORT = port of STEP pin. <br />
 uint16_t STEP_PIN = STEP pin. <br />
 GPIO_TypeDef *DIR_P = Port of DIRECCION pin. <br />
 GPIO_TypeDef *DIR_PORT = DIRECCION pin. <br />
</p>
<h1><a class="anchor" id="sec2"></a>
Example code</h1>
<div class="fragment"><div class="line"><a class="code" href="structa4988_handler.html">a4988Handler</a> motor1;</div><div class="line"><span class="keywordtype">void</span> main(){</div><div class="line">    <a class="code" href="a4988_8c.html#a83a5e4ad4b743e7a5e5e3667d5b5af90">a4988_init</a>(&amp;motor1,A4988_EN1_GPIO_Port, A4988_EN1_Pin, A4988_STP1_GPIO_Port, A4988_STP1_Pin , A4988_DIR1_GPIO_Port, A4988_DIR1_Pin);</div><div class="line">    <a class="code" href="a4988_8c.html#a957c1d38216e19e2d33514fba8290797">a4988_setSpeed</a>(&amp;motor1, 15);</div><div class="line">    <a class="code" href="a4988_8c.html#aac1c631bf4552cbc8e1af42cf426f154">a4988_setStatus</a>(&amp;motor1,<a class="code" href="a4988_8h.html#a6086cd48f9d99d3c531787235d509622a33cf1d8ef1d06ee698a7fabf40eb3a7f">ACTIVE</a>);</div><div class="line">    HAL_Delay(100);</div><div class="line">    <a class="code" href="a4988_8c.html#a616386d44c4d6ab3acd4bfe79f4526c3">a4988_incSteps</a>(&amp;motor1, 400);</div><div class="line">}</div></div><!-- fragment --> </div><h2 class="groupheader">Enumeration Type Documentation</h2>
<a id="a6086cd48f9d99d3c531787235d509622"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6086cd48f9d99d3c531787235d509622">&#9670;&nbsp;</a></span>driverStatus</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="a4988_8h.html#a6086cd48f9d99d3c531787235d509622">driverStatus</a></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Possible status of the driver. </p>
<dl class="bug"><dt><b><a class="el" href="bug.html#_bug000001">Bug:</a></b></dt><dd>SLEEP is no implemented </dd></dl>
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="a6086cd48f9d99d3c531787235d509622a33cf1d8ef1d06ee698a7fabf40eb3a7f"></a>ACTIVE&#160;</td><td class="fielddoc"><p>ACTIVE state. </p>
</td></tr>
<tr><td class="fieldname"><a id="a6086cd48f9d99d3c531787235d509622aac132f2982b98bcaa3445e535a03ff75"></a>OFF&#160;</td><td class="fielddoc"><p>OFF state. </p>
</td></tr>
<tr><td class="fieldname"><a id="a6086cd48f9d99d3c531787235d509622ad6137abebe4fdc59e2f0f2c84bdbe3fa"></a>SLEEP&#160;</td><td class="fielddoc"><p>SLEEP state. </p>
</td></tr>
</table>

</div>
</div>
<a id="a26a4a9fc10f890a34859f53d114f08b0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a26a4a9fc10f890a34859f53d114f08b0">&#9670;&nbsp;</a></span>microStep</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0">microStep</a></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Microsteps set in the driver by pins MS1, MS2, MS3. </p>
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="a26a4a9fc10f890a34859f53d114f08b0ad08f8ac0aa8dfb59589824359772459e"></a>FULL&#160;</td><td class="fielddoc"><p>FULL step (no microstepping) </p>
</td></tr>
<tr><td class="fieldname"><a id="a26a4a9fc10f890a34859f53d114f08b0a51df22c376649e022134d738e8d8641a"></a>HALF&#160;</td><td class="fielddoc"><p>1/2 of a step </p>
</td></tr>
<tr><td class="fieldname"><a id="a26a4a9fc10f890a34859f53d114f08b0a8dd9342a0e4fd716d2beb9961f5deeed"></a>QUARTER&#160;</td><td class="fielddoc"><p>1/4 of a step </p>
</td></tr>
<tr><td class="fieldname"><a id="a26a4a9fc10f890a34859f53d114f08b0a2fd39b67b424f4ea3b4c11ce3195ab8b"></a>EIGHT&#160;</td><td class="fielddoc"><p>1/8 of a step </p>
</td></tr>
<tr><td class="fieldname"><a id="a26a4a9fc10f890a34859f53d114f08b0a3cc9428274f66ec477863bbf676438c8"></a>SIXTEENTH&#160;</td><td class="fielddoc"><p>1/16 of a step </p>
</td></tr>
</table>

</div>
</div>
<h2 class="groupheader">Function Documentation</h2>
<a id="a25f9bb9576d05153c805e499b5ead280"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a25f9bb9576d05153c805e499b5ead280">&#9670;&nbsp;</a></span>a4988_decStep()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool a4988_decStep </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structa4988_handler.html">a4988Handler</a> *&#160;</td>
          <td class="paramname"><em>driver_handler</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Decrements a simgle step in the motor. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">driver_handler</td><td>Struct pointer to the driver to be affect. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>True if no error, False if something fails. </dd></dl>

</div>
</div>
<a id="a694a6c6580c3e70029ecf890b18662d9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a694a6c6580c3e70029ecf890b18662d9">&#9670;&nbsp;</a></span>a4988_decSteps()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool a4988_decSteps </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structa4988_handler.html">a4988Handler</a> *&#160;</td>
          <td class="paramname"><em>driver_handler</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>steps</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Decrements an specific amount of steps in the motor. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">driver_handler</td><td>Struct pointer to the driver to be affect. </td></tr>
    <tr><td class="paramname">steps</td><td>number of steps to be incremented. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>True if no error, False if something fails. </dd></dl>

</div>
</div>
<a id="a05f902e3d1ee0b82d70fa65d8955423b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a05f902e3d1ee0b82d70fa65d8955423b">&#9670;&nbsp;</a></span>a4988_getDegreeCount()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">float a4988_getDegreeCount </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structa4988_handler.html">a4988Handler</a> *&#160;</td>
          <td class="paramname"><em>driver_handler</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get how many degrees has the motor rotated. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">driver_handler</td><td>Struct pointer to the driver to be affect. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>number of steps tajen by the motor. </dd></dl>

</div>
</div>
<a id="ab2c561e95b718d8f275f41f7ec44113b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab2c561e95b718d8f275f41f7ec44113b">&#9670;&nbsp;</a></span>a4988_getSteps()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int64_t a4988_getSteps </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structa4988_handler.html">a4988Handler</a> *&#160;</td>
          <td class="paramname"><em>driver_handler</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>returns the number of steps that the motor has made. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">driver_handler</td><td>Struct pointer to the driver to be affect. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>number of steps that the motor has made. </dd></dl>

</div>
</div>
<a id="a6cd8fcd5ab73faea97783466d496782b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6cd8fcd5ab73faea97783466d496782b">&#9670;&nbsp;</a></span>a4988_incStep()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool a4988_incStep </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structa4988_handler.html">a4988Handler</a> *&#160;</td>
          <td class="paramname"><em>driver_handler</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Increments a step in the motor. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">driver_handler</td><td>Struct point to the driver to affect. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>True if no error, False if something fails. </dd></dl>

</div>
</div>
<a id="a616386d44c4d6ab3acd4bfe79f4526c3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a616386d44c4d6ab3acd4bfe79f4526c3">&#9670;&nbsp;</a></span>a4988_incSteps()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool a4988_incSteps </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structa4988_handler.html">a4988Handler</a> *&#160;</td>
          <td class="paramname"><em>driver_handler</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>steps</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Increments an specific amount of steps in the motor. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">driver_handler</td><td>Struct pointer to the driver to be affect. </td></tr>
    <tr><td class="paramname">steps</td><td>How many steps do you want to move. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>True if no error, False if something fails. </dd></dl>

</div>
</div>
<a id="a83a5e4ad4b743e7a5e5e3667d5b5af90"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a83a5e4ad4b743e7a5e5e3667d5b5af90">&#9670;&nbsp;</a></span>a4988_init()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void a4988_init </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structa4988_handler.html">a4988Handler</a> *&#160;</td>
          <td class="paramname"><em>driver_handler</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">GPIO_TypeDef *&#160;</td>
          <td class="paramname"><em>en_port</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>en_pin</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">GPIO_TypeDef *&#160;</td>
          <td class="paramname"><em>step_port</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>step_pin</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">GPIO_TypeDef *&#160;</td>
          <td class="paramname"><em>dir_port</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>dir_pin</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Initialize the driver. Assigns the pins for each control in order to control the motor. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">driver_handler</td><td>pointer to struct which saves all the data. </td></tr>
    <tr><td class="paramname">en_port</td><td>port of pin ENABLE. </td></tr>
    <tr><td class="paramname">en_pin</td><td>pin ENABLE. </td></tr>
    <tr><td class="paramname">step_port</td><td>port of pin STEP. </td></tr>
    <tr><td class="paramname">step_pin</td><td>pin STEP. </td></tr>
    <tr><td class="paramname">dir_port</td><td>port of pin DIRECTION. </td></tr>
    <tr><td class="paramname">dir_pin</td><td>pin DIRECTION. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>void </dd></dl>

</div>
</div>
<a id="a4636e615969f0762717be85f3fae99b2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4636e615969f0762717be85f3fae99b2">&#9670;&nbsp;</a></span>a4988_resetSteps()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void a4988_resetSteps </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structa4988_handler.html">a4988Handler</a> *&#160;</td>
          <td class="paramname"><em>driver_handler</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Reset the step count of the motor. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">driver_handler</td><td>Struct pointer to the driver to be affect. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a50b770ddd61a733c0b93674a6e043941"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a50b770ddd61a733c0b93674a6e043941">&#9670;&nbsp;</a></span>a4988_setMicroStep()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void a4988_setMicroStep </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structa4988_handler.html">a4988Handler</a> *&#160;</td>
          <td class="paramname"><em>driver_handler</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0">microStep</a>&#160;</td>
          <td class="paramname"><em>step</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Sets how many microsteps are set in Pololu driver To check hoe many microsteps are configured, check MS1, MS2 and MS3. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">driver_handler</td><td>Struct pointer to the driver to be affect. </td></tr>
    <tr><td class="paramname">step</td><td>number of microsteps to increment. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a957c1d38216e19e2d33514fba8290797"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a957c1d38216e19e2d33514fba8290797">&#9670;&nbsp;</a></span>a4988_setSpeed()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void a4988_setSpeed </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structa4988_handler.html">a4988Handler</a> *&#160;</td>
          <td class="paramname"><em>driver_handler</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>speed</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Calculates the delay of each step in order to reach the desired speed. In order to calculate it properly, microsteps and steps per turn must be set. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">driver_handler</td><td>Struct pointer to the driver to be affect. </td></tr>
    <tr><td class="paramname">speed</td><td>Desired speed of the motor in rads/seg. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="aac1c631bf4552cbc8e1af42cf426f154"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aac1c631bf4552cbc8e1af42cf426f154">&#9670;&nbsp;</a></span>a4988_setStatus()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void a4988_setStatus </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structa4988_handler.html">a4988Handler</a> *&#160;</td>
          <td class="paramname"><em>driver_handler</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="a4988_8h.html#a6086cd48f9d99d3c531787235d509622">driverStatus</a>&#160;</td>
          <td class="paramname"><em>status</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the motor to ACTIVE or OFF. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">driver_handler</td><td>Struct pointer to the driver to be affect. </td></tr>
    <tr><td class="paramname">status</td><td>ACTIVE or OFF. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a8c6e8d00fb33d5b8d8b1be976b2d8773"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8c6e8d00fb33d5b8d8b1be976b2d8773">&#9670;&nbsp;</a></span>a4988_setSteps()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void a4988_setSteps </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structa4988_handler.html">a4988Handler</a> *&#160;</td>
          <td class="paramname"><em>driver_handler</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int64_t&#160;</td>
          <td class="paramname"><em>steps</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set a new amount of steps taken. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">driver_handler</td><td>Struct pointer to the driver to be affect. </td></tr>
    <tr><td class="paramname">steps</td><td>number of steps taken by the motor. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a2c4fb12bcdcffea40744538616b5f7e4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2c4fb12bcdcffea40744538616b5f7e4">&#9670;&nbsp;</a></span>a4988_setStepsPerTurn()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void a4988_setStepsPerTurn </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structa4988_handler.html">a4988Handler</a> *&#160;</td>
          <td class="paramname"><em>driver_handler</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>steps</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the amount of steps to make in order to rotate a turn. DO NOT TAKE IN COUNT MICROSTEPS. See Stepper motor datasheet. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">driver_handler</td><td>driver_handler Struct pointer to the driver to be affect. </td></tr>
    <tr><td class="paramname">steps</td><td>number of steps of the motor. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
